require("guiLib/guiLib")

------------------------------------------------------------
-- The elements of the store
------------------------------------------------------------

storeProducts = {}

function addStoreProduct(name, depName, description, cost, icon, pos, dependencies, activateFn)
	local elem = {}
	elem["isOn"] = false
	elem["name"] = name
	elem["depName"] = depName
	elem["description"] = description
	elem["cost"] = cost
	--elem["icon"] = icon
	elem["pos"] = pos
	elem["dependencies"] = dependencies
	elem["activateFn"] = activateFn
	
	-- Texture => Choix du plus grand text contenu dans depName
	local maxLen = -1
	local maxId = 1 -- Si pas trouvé => texture n°1
	for i = 1, #logoNameTbl do
		if string.find(string.lower(elem.depName), string.lower(logoNameTbl[i]), 1, true) and (maxLen < string.len(logoNameTbl[i])) then
			maxLen = string.len(logoNameTbl[i])
			maxId = i
		end
	end
	
	elem["icon"] = logoTexTbl[maxId]
	
	
	table.insert(storeProducts, elem)
end

function findIdFromDepName(depName)
	for i = 1, #storeProducts do
		if storeProducts[i]["depName"] == depName then
			return i
		end
	end
	
	printError("No product with depName == '" .. depName .. "' found !")
	Quit()
	return nil
end

-- Life
function getPos(coord)
	return Vector2D(50, 50) + coord * 100
end

addStoreProduct(_("Energy max +250"), "lifeMax+1", _("Boost your energy with this bonus. You will be able to resist more before your shield fail."), 1000, bidonEnergyTex, getPos(Vector2D(0, 0)), {}, function ()
																																	improveMaxLife(250)
																																end)
addStoreProduct(_("Energy max +250"), "lifeMax+2", _("Boost even more your energy with this bonus. You will be able to resist more before your shield fail."), 3000, bidonEnergyTex, getPos(Vector2D(0, 1)), {"lifeMax+1"}, function ()
																																	improveMaxLife(250)
																																end)
addStoreProduct(_("Energy reload +20%"), "lifeSpeed1", _("Energy is reloaded 20% faster ! This improvement is very important to recover faster after beeing hit by an enemy."), 3000, bidonEnergyTex, getPos(Vector2D(1, 1)), {"lifeMax+2"}, function ()
																																	lifeRecoveryAcceleration = lifeRecoveryAcceleration * 1.2
																																end)
addStoreProduct(_("Energy max +300"), "lifeMax+3", _("Boost even more your energy with this bonus. You will be able to resist more before your shield fail."), 6000, bidonEnergyTex, getPos(Vector2D(0, 2)), {"lifeMax+2"}, function ()
																																	improveMaxLife(300)
																																end)
addStoreProduct(_("Max energy reloading speed +10%"), "lifeMaxSpeed1", _("When your are not hurt by enemies for a long time, your life can reload even faster !"), 6000, bidonEnergyTex, getPos(Vector2D(1, 2)), {"lifeMax+3"}, function ()
																																	lifeRecoveryMaxSpeed = lifeRecoveryMaxSpeed * 1.1
																																end)
addStoreProduct(_("Energy max +200"), "lifeMax+4", _("Boost even more your energy with this bonus. You will be able to resist more before your shield fail."), 7000, bidonEnergyTex, getPos(Vector2D(0, 3)), {"lifeMax+3"}, function ()
																																	improveMaxLife(200)
																																end)
addStoreProduct(_("Energy reload +15%"), "lifeSpeed2", _("Energy is reloaded 15% faster ! This improvement is very important to recover faster after beeing hit by an enemy."), 9000, bidonEnergyTex, getPos(Vector2D(1, 3)), {"lifeMax+4"}, function ()
																																	lifeRecoveryAcceleration = lifeRecoveryAcceleration * 1.15
																																end)
addStoreProduct(_("Energy max +200"), "lifeMax+5", _("Boost even more your energy with this bonus. You will be able to resist more before your shield fail."), 7000, bidonEnergyTex, getPos(Vector2D(0, 4)), {"lifeMax+4"}, function ()
																																	improveMaxLife(200)
																																end)
addStoreProduct(_("Energy max +200"), "lifeMax+6", _("Boost even more your energy with this bonus. You will be able to resist more before your shield fail."), 10000, bidonEnergyTex, getPos(Vector2D(0, 5)), {"lifeMax+5"}, function ()
																																	improveMaxLife(200)
																																end)
addStoreProduct(_("Energy max +200"), "lifeMax+7", _("Boost even more your energy with this bonus. You will be able to resist more before your shield fail."), 15000, bidonEnergyTex, getPos(Vector2D(1, 5)), {"lifeMax+6"}, function ()
																																	improveMaxLife(200)
																																end)
addStoreProduct(_("Energy reload +10%"), "lifeSpeed3", _("Energy is reloaded 10% faster ! This improvement is very important to recover faster after beeing hit by an enemy."), 20000, bidonEnergyTex, getPos(Vector2D(2, 5)), {"lifeMax+7"}, function ()
																																	lifeRecoveryAcceleration = lifeRecoveryAcceleration * 1.10
																																end)
-- Laser
function getPos(coord)
	return Vector2D(250 + 100 / 3, 50) + coord * 100
end

addStoreProduct(_("Laser weapon"), "laser", _("Use the laser weapon to destroy a line of enemy in one shot !"), 2000, bidonEnergyTex, getPos(Vector2D(0, 0)), {}, function ()
																						enableWeapon("laser", true)
																					end)
addStoreProduct(_("Reload speed +10%"), "laserReloadSpeed+1", _("Improve the laser reload speed (+10%). With this improvement you can use the laser more often."), 2000, bidonEnergyTex, getPos(Vector2D(1, 0)), {"laser"}, function ()
																						laserWaitTime = laserWaitTime * 0.9
																					end)
addStoreProduct(_("Reload speed +10%"), "laserReloadSpeed+2", _("Improve the laser reload speed (+10%). With this improvement you can use the laser more often."), 2500, bidonEnergyTex, getPos(Vector2D(2, 0)), {"laserReloadSpeed+1"}, function ()
																						laserWaitTime = laserWaitTime * 0.9
																					end)
addStoreProduct(_("Reload speed +10%"), "laserReloadSpeed+3", _("Improve the laser reload speed (+10%). With this improvement you can use the laser more often."), 3500, bidonEnergyTex, getPos(Vector2D(3, 0)), {"laserReloadSpeed+2"}, function ()
																						laserWaitTime = laserWaitTime * 0.9
																					end)
addStoreProduct(_("Reload speed +10%"), "laserReloadSpeed+4", _("Improve the laser reload speed (+10%). With this improvement you can use the laser more often."), 5000, bidonEnergyTex, getPos(Vector2D(3, 1)), {"laserReloadSpeed+3"}, function ()
																						laserWaitTime = laserWaitTime * 0.9
																					end)
addStoreProduct(_("Reload speed +10%"), "laserReloadSpeed+5", _("Improve the laser reload speed (+10%). With this improvement you can use the laser more often."), 10000, bidonEnergyTex, getPos(Vector2D(2, 1)), {"laserReloadSpeed+4"}, function ()
																						laserWaitTime = laserWaitTime * 0.9
																					end)
addStoreProduct(_("Reload speed +10%"), "laserReloadSpeed+6", _("Improve the laser reload speed (+10%). With this improvement you can use the laser more often."), 15000, bidonEnergyTex, getPos(Vector2D(1, 1)), {"laserReloadSpeed+5"}, function ()
																						laserWaitTime = laserWaitTime * 0.9
																					end)

-- Freeze weapon
function getPos(coord)
	return Vector2D(250 + 100 / 3, 250 + 100 / 3) + coord * 100
end

addStoreProduct(_("Freeze Weapon"), "freezeWeapon", _("The freezer weapon ! It can slow down your enemies, to you have more time to destroy them !"), 1000, bidonEnergyTex, getPos(Vector2D(0, 0)), {}, function ()
																						enableWeapon("freezeWeapon", true)
																					end)
addStoreProduct(_("Freezer reload speed +10%"), "freezeReloadSpeed+1", _("Improve the freeze weapon reload speed (+10%)"), 2000, bidonEnergyTex, getPos(Vector2D(1, 0)), {"freezeWeapon"}, function ()
																						freezeWeaponWaitTime = freezeWeaponWaitTime * 0.9
																					end)
addStoreProduct(_("Freeze slow down +40%"), "freezeSlowDown+1", _("Improve the freeze weapon slow down (+40%). This bonus enable you to slow down your enemies even more then they are hit by the freezer."), 2000, bidonEnergyTex, getPos(Vector2D(2, 0)), {"freezeReloadSpeed+1"}, function ()
																						freezeWeaponSlowDown = freezeWeaponSlowDown * 1.4
																					end)
addStoreProduct(_("Freezer reload speed +10%"), "freezeReloadSpeed+2", _("Improve the freeze weapon reload speed (+10%)"), 2000, bidonEnergyTex, getPos(Vector2D(3, 0)), {"freezeSlowDown+1"}, function ()
																						freezeWeaponWaitTime = freezeWeaponWaitTime * 0.9
																					end)
addStoreProduct(_("Bonus will fall"), "freezeWeaponMakeBonusFall", _("When hit by the freezer, the parachutes holding the bonus are destroyed by the blow. This enable you to get the bonus without destroying them."), 2000, bidonEnergyTex, getPos(Vector2D(1, 1)), {"freezeReloadSpeed+1"}, function ()
																						freezeWeaponMakeBonusFall = true
																					end)
addStoreProduct(_("Small missiles are destroyed"), "freezeWeaponKillSmallMissile", _("Small missiles will be destroyed when hit by the freeze weapon."), 2000, bidonEnergyTex, getPos(Vector2D(1, 2)), {"freezeWeaponMakeBonusFall"}, function ()
																						freezeWeaponKillSmallMissile = true
																					end)
addStoreProduct(_("Freeze slow down +15%"), "freezeSlowDown+2", _("Improve the freeze weapon slow down (+15%). This bonus enable you to slow down your enemies even more then they are hit by the freezer."), 5000, bidonEnergyTex, getPos(Vector2D(2, 1)), {"freezeSlowDown+1"}, function ()
																						freezeWeaponSlowDown = freezeWeaponSlowDown * 1.15
																					end)
addStoreProduct(_("Reset shield vaccum"), "freezeWeaponResetVaccum", _("Vaccum enemies are reseted when hit by the blow (they have to connect to the shield again)."), 3000, bidonEnergyTex, getPos(Vector2D(3, 1)), {"freezeReloadSpeed+2"}, function ()
																						freezeWeaponResetVaccum = true
																					end)
 -- Reinit vaccum


-- Normal weapon
function getPos(coord)
	return Vector2D(650 + 100 / 3 * 2, 50) + coord * 100
end

addStoreProduct(_("Reload speed +10%"), "reloadSpeed+1", _("Improve the normal weapon reload speed (+10%)"), 1000, bidonEnergyTex, getPos(Vector2D(0, 0)), {}, function ()
																						shootWaitTime = shootWaitTime * 0.9
																					end)
addStoreProduct(_("Damage per bullet x2"), "damage+1", _("Damage per bullet are multiplied per two"), 1000, bidonEnergyTex, getPos(Vector2D(0, 1)), {"reloadSpeed+1"}, function ()
																						stockBullet:SetUserData("damage", stockBullet:GetUserData("damage") * 2)
																					end)
addStoreProduct(_("Bullet speed +20%"), "bulletSpeed+1", _("Bullet speed are increased by 20%"), 2000, bidonEnergyTex, getPos(Vector2D(1, 1)), {"damage+1"}, function ()
																						bulletSpeed = bulletSpeed * 1.2
																					end)
addStoreProduct(_("Bullet speed +15%"), "bulletSpeed+2", _("Bullet speed are increased by 20%"), 3000, bidonEnergyTex, getPos(Vector2D(0, 2)), {"damage+1"}, function ()
																						bulletSpeed = bulletSpeed * 1.15
																					end)
addStoreProduct(_("Reload speed +10%"), "reloadSpeed+2", _("Improve the normal weapon reload speed (+10%)"), 1000, bidonEnergyTex, getPos(Vector2D(1, 2)), {"bulletSpeed+2"}, function ()
																						shootWaitTime = shootWaitTime * 0.9
																					end)
addStoreProduct(_("Reload speed +10%"), "reloadSpeed+3", _("Improve the normal weapon reload speed (+10%)"), 2000, bidonEnergyTex, getPos(Vector2D(0, 3)), {"bulletSpeed+2"}, function ()
																						shootWaitTime = shootWaitTime * 0.9
																					end)
addStoreProduct(_("Reload speed +15%"), "reloadSpeed+4", _("Improve the normal weapon reload speed (+15%)"), 4000, bidonEnergyTex, getPos(Vector2D(0, 4)), {"reloadSpeed+3"}, function ()
																						shootWaitTime = shootWaitTime * 0.85
																					end)
addStoreProduct(_("Damage per bullet +50%"), "damage+2", _("Damage per bullet are multiplied per 1.5"), 3000, bidonEnergyTex, getPos(Vector2D(1, 4)), {"reloadSpeed+4"}, function ()
																						stockBullet:SetUserData("damage", stockBullet:GetUserData("damage") * 1.5)
																					end)
addStoreProduct(_("Reload speed +15%"), "reloadSpeed+5", _("Improve the normal weapon reload speed (+15%)"), 7000, bidonEnergyTex, getPos(Vector2D(0, 5)), {"reloadSpeed+4"}, function ()
																						shootWaitTime = shootWaitTime * 0.85
																					end)
addStoreProduct(_("Damage per bullet +25%"), "damage+3", _("Damage per bullet are multiplied per 1.25"), 5000, bidonEnergyTex, getPos(Vector2D(1, 5)), {"reloadSpeed+5"}, function ()
																						stockBullet:SetUserData("damage", stockBullet:GetUserData("damage") * 1.25)
																					end)
addStoreProduct(_("Reload speed +15%"), "reloadSpeed+6", _("Improve the normal weapon reload speed (+15%)"), 10000, bidonEnergyTex, getPos(Vector2D(-1, 5)), {"reloadSpeed+5"}, function ()
																						shootWaitTime = shootWaitTime * 0.85
																					end)
addStoreProduct(_("Reload speed +15%"), "reloadSpeed+7", _("Improve the normal weapon reload speed (+15%)"), 20000, bidonEnergyTex, getPos(Vector2D(-2, 5)), {"reloadSpeed+6"}, function ()
																						shootWaitTime = shootWaitTime * 0.85
																					end)



-- Utils
function getPos(coord)
	return Vector2D(850 + 100, 50) + coord * 100
end

addStoreProduct(_("Laser sight"), "sight", _("Shoot your enemies become easier with the laser sight. It helps you to target your enemies."), 1500, bidonEnergyTex, getPos(Vector2D(0, 0)), {}, function ()
																																			enableWeapon("sight", true);
																																		end)
addStoreProduct(_("Laser alert"), "laserAlert", _("An alarm will ring when the laser is ready to be used."), 1000, bidonEnergyTex, getPos(Vector2D(0, 1)), {}, function ()
																																			useLaserAlarm = true
																																		end)
addStoreProduct(_("Freeze Weapon alert"), "freezeWeaponAlert", _("An alarm will ring when the freeze weapon is ready to be used."), 1000, bidonEnergyTex, getPos(Vector2D(0, 2)), {}, function ()
																																			useFreezeWeaponAlarm = true
																																		end)


------------------------------------------------------------
-- The store code
------------------------------------------------------------

-- Create screen
storeScreen = CreateScreen("storeScreen", ScreenConfig(screenSize))

-- Game on background
local tmp = storeScreen:CreateScreenRenderer("gameRenderer")
tmp:SetTargetScreen(gameScreen)

-- Blur
local tmp = storeScreen:CreatePostFX("blurEffect")
tmp:LoadFromFile(GetCommonDataPath() .. "/blur.sfx")

-- Shape
storeGrp = storeScreen:CreateGroup("storeGrp")
storeGrp:SetPosition(Vector2D(screenSize.x, 0))

rectMargin = Vector2D(100, 100)
--local tmp = storeGrp:CreateShapeRectangle("backRect", rectMargin, screenSize - rectMargin, Color(0, 0, 30, 220), 2, Color(0, 0, 255))
--tmp:SetZpos(-1000)

-- Bg tex
local tmp = storeGrp:CreateSprite("store_back")
tmp:SetImage(storeBackgroundTex)
tmp:SetPosition(screenSize / 2 - tmp:GetSize() / 2)
tmp:SetZpos(-1000)

-- Label
local tmp = storeGrp:CreateText("", _("Store"))
tmp:SetSize(32)
tmp:SetPosition(Vector2D(228, 88) - Vector2D(tmp:GetTextSize().x / 2, 0))
tmp:SetColor(Color(0, 0, 0))

local tmp = storeGrp:CreateText("cashText", "")
tmp:SetSize(32)
tmp:SetColor(Color(0, 0, 0))



local inRectGrp = storeGrp:CreateGroup("inRectGrp")
inRectGrp:SetPosition(rectMargin + Vector2D(10, 10))

local inRectSize = screenSize - (rectMargin + Vector2D(10, 10)) * 2

-- Separation bar
local tmp = inRectGrp:CreateShapeLine("separationBar", Vector2D(-10, inRectSize.y - 100 - 30 - 5), Vector2D(inRectSize.x + 10, inRectSize.y - 100 - 30 - 5), 8, Color(0, 0, 0), 0, Color(0, 0, 0))

-- Name text
local tmp = inRectGrp:CreateText("nameText", "")
tmp:SetSize(30)
tmp:SetBold(true)
tmp:SetPosition(Vector2D(0, inRectSize.y - 100 - 30))

-- Description text
local tmp = inRectGrp:CreateText("descriptionText", "")
tmp:SetSize(25)
tmp:SetMaxWidth(inRectSize.x)
tmp:SetPosition(Vector2D(0, inRectSize.y - 100))

-- Info text
local tmp = inRectGrp:CreateText("InfoText", "")
tmp:SetSize(25)
tmp:SetMaxWidth(inRectSize.x)
tmp:SetPosition(Vector2D(0, 0))

-- Products
function storeOnBtOver(bt, isInside)
	local id = bt:GetUserData("itemId")
	local description = inRectGrp:FindByNameText("descriptionText")
	local name = inRectGrp:FindByNameText("nameText")
	local info = inRectGrp:FindByNameText("InfoText")
	
	if isInside then
		local item = storeProducts[id]
	
		description:SetText(item["description"])
		name:SetText(storeProducts[id]["name"] .. " - " .. tostring(item["cost"]) .. "$")
		
		if item["isOn"] then -- Bought
			info:SetColor(Color(0, 255, 0))
			info:SetText(_("You have already bought this product"))
		elseif bt:FindByNameSprite("disabledIcon"):IsVisible() then
			info:SetColor(Color(255, 0, 0))
		
			-- Dep test
			local depOk = true
			local depList = item["dependencies"]
			for j = 1, #depList do
				local depId = findIdFromDepName(depList[j])
				if storeProducts[depId]["isOn"] == false then
					depOk = false
					break
				end
			end
			
			if depOk == false then
				info:SetText(_("You must buy other products before you can buy this one."))
			else
				info:SetText(_("You don't have enough cash to buy this product."))
			end
		else
			info:SetColor(Color(0, 0, 255))
			info:SetText(_("You can buy this product"))
		end
		
		info:SetPositionY(description:GetPosition().y + description:GetTextSize().y)
	else
		name:SetText("")
		description:SetText("")
		info:SetText("")
	end
end

btSize = storeBtNormalTex:GetSize()

function storeOnBtClick(group)
	local id = group:GetUserData("itemId")
	local item = storeProducts[id]

	-- Fn
	item["activateFn"](group)
	
	-- Active
	ChangeCash(- item["cost"])
	item["isOn"] = true
	group:FindByNameSprite("disabledIcon"):SetImage(storeBtOnTex)
	
	-- Refresh
	RefreshStore()
	
	-- Refresh msg
	storeOnBtOver(group, true)
end

for i = 1, #storeProducts do
	-- Item bt
	local item = storeProducts[i]

	local bt = inRectGrp:CreateGroup("storeItemBt_" .. tostring(i))
	buttonControlCreate(bt, "", btSize)
	buttonSetEventFunction(bt, 	storeOnBtClick)
	buttonSetOverFunction(bt, storeOnBtOver)
	bt:SetUserData("itemId", i)
	buttonSetFontSize(bt, 16)
	buttonSetImagePack(bt, storeBtNormalTex, storeBtOverTex, storeBtPressedTex)
	bt:SetPosition(item["pos"])
	
	local tmp = bt:CreateSprite("icon")
	tmp:SetImage(item["icon"])
	tmp:SetPosition((btSize - tmp:GetSize()) / 2)
	
	local tmp = bt:CreateSprite("disabledIcon")
	tmp:SetImage(storeBtDisabledTex)
	tmp:SetSize(btSize)
	
	-- Dependency
	depList = item["dependencies"]
	for j = 1, #depList do
		local depId = findIdFromDepName(depList[j])
	
		local tmp = inRectGrp:CreateShapeLine("depLine", bt:GetPosition() + btSize / 2, inRectGrp:FindByNameGroup("storeItemBt_" .. tostring(depId)):GetPosition() + btSize / 2, 10, Color(255, 255, 255), 0, Color(0, 0, 0))
		tmp:SetZpos(-100)
	end
end

function RefreshStore()
	-- Cash
	local tmp = storeGrp:FindByNameText("cashText")
	tmp:SetText(tostring(cash) .. " $")
	tmp:SetPosition(Vector2D(1050, 88) - Vector2D(tmp:GetTextSize().x / 2, 0))

	
	-- Enable / disable
	for i = 1, #storeProducts do	
		local item = storeProducts[i]
		
		local isEnabled = ((cash >= item["cost"]) and (item["isOn"] == false))
		
		-- Test de dépendance
		if isEnabled then
			depList = item["dependencies"]
			for j = 1, #depList do
				local depId = findIdFromDepName(depList[j])
				if storeProducts[depId]["isOn"] == false then
					isEnabled = false
					break
				end
			end
		end
		
		-- Param
		local bt = inRectGrp:FindByNameGroup("storeItemBt_" .. tostring(i))
		buttonEnable(bt, isEnabled)
		
		bt:FindByNameSprite("disabledIcon"):Show(not isEnabled)
	end
end

-- Event go back to game
function store_quitStoreEvent() 
	createMovingBlockAnim(storeScreen:FindByName("storeGrp"), Vector2D(screenSize.x, 0), Vector2D(0, 0), 0.75, true, function() ChangeScreen(gameScreen); end)
end

storeScreen:RegisterButtonEvent(store_quitStoreEvent, "Escape", true)
storeScreen:RegisterButtonEvent(store_quitStoreEvent, "Tab", true)


-- Anim
function store_backRectAnimFn(ratio, event)
	-- Get vars
	local object = event:GetUserData("object")

	local endPos = event:GetUserData("endPos")
	local startPos = event:GetUserData("startPos")
	
	-- Acceleration ratio
	if event:GetUserData("isEntering") then
		ratio = ConvertRatioDeceleration(ratio, 9)
	else
		ratio = ConvertRatioAcceleration(ratio, 9)
	end
		
	-- Move
	object:SetPosition(startPos - (startPos - endPos) * ratio)
	
	if ratio == 1 then	
		-- We destroy the event => it should not be accessed anymore
		object:SetUserData("animEvent", nil)
		event:Destroy()
		
		-- Callback function
		if event:UserDataExists("callbackEndFn") then
			event:GetUserData("callbackEndFn")(object, event)
		end
	end
end

function createMovingBlockAnim(object, startPos, endPos, duration, isOverWay, finishedFn)
	-- Abort if an event already exists
	--[[if object:UserDataExists("animEvent") and object:GetUserData("animEvent") ~= nil then
		if object:GetUserData("animEvent"):ShouldBeDestroyed() then
			printErrorConsole("Zombie !!!!")
		end

		return
	end]]

	-- Swap if needed
	if isOverWay then
		tmp = startPos
		startPos = endPos
		endPos = tmp
	end

	-- Create event
	local event = object:GetParentScreen():RegisterChronometer(store_backRectAnimFn, duration, true)
	event:SetUserData("isEntering", not isOverWay)
	event:SetUserData("startPos", startPos)
	event:SetUserData("endPos", endPos)
	event:SetUserData("object", object)
	
	-- Destroy any previous event
	if object:UserDataExists("animEvent") then		
		local backEvent = object:GetUserData("animEvent")
		if backEvent ~= nil then		
			-- We continue the movement => we get the previous ratio
			if event:GetUserData("isEntering") == backEvent:GetUserData("isEntering") then -- Same way
				event.ratio = backEvent.ratio
			else
				event.ratio = 1 - backEvent.ratio
			end
		
			backEvent:Destroy()
		end
	end
	
	-- Save event in the object (to destroy it if needed)
	object:SetUserData("animEvent", event)
	
	-- Finished function
	if type(finishedFn) == "function" then
		event:SetUserData("callbackEndFn", finishedFn)
	end
end
